@echo off

if not [%1] == [] pushd %1

rem ------------------------------
rem create directories

echo Create runtime image directories ...
if not exist ..\Output mkdir ..\Output
if not exist bin\windows\xml mkdir bin\windows\xml
if not exist bin\windows\doc mkdir bin\windows\doc
if not exist bin\windows\fonts mkdir bin\windows\fonts
if not exist bin\windows\images\structs mkdir bin\windows\images\structs
if not exist bin\windows\images\textures mkdir bin\windows\images\textures
if not exist bin\windows\images\grt\db mkdir bin\windows\images\grt\db
if not exist bin\windows\lua mkdir bin\windows\lua
rem if not exist bin\windows\php mkdir bin\windows\php
if not exist bin\windows\scripts mkdir bin\windows\scripts
echo .

rem ------------------------------
rem copy appropriate licence

echo Copying licence files ...
if exist bin\windows\COPYING del bin\windows\COPYING
if exist bin\windows\MySQLEULA.txt del bin\windows\MySQLEULA.txt

copy ..\common\res\COPYING bin\windows\COPYING
echo .

rem ------------------------------
rem copy xml files

echo Copying XML files...
copy ..\common\res\grt\structs*.xml bin\windows\xml\
copy ..\common\res\grt\layout*.xml bin\windows\xml\

copy res\grt\structs.db.workbench.xml bin\windows\xml\
echo .

rem ------------------------------
rem copy docs

echo Copying doc files...
echo .

rem ------------------------------
rem copy fonts

echo Copying font files...
copy ..\common\res\fonts\VeraMoBd.ttf bin\windows\fonts\VeraMoBd.ttf
copy ..\common\res\fonts\VeraMoBI.ttf bin\windows\fonts\VeraMoBI.ttf
copy ..\common\res\fonts\VeraMoIt.ttf bin\windows\fonts\VeraMoIt.ttf
copy ..\common\res\fonts\VeraMono.ttf bin\windows\fonts\VeraMono.ttf
echo .

rem ------------------------------
rem copy jars

echo Copying third party jars
if not exist ..\common\source\java\lib\jtds-1.2.jar copy ..\common\res\java\jtds-1.2.jar ..\common\source\java\lib\jtds-1.2.jar
if not exist ..\common\source\java\lib\junit.jar copy ..\common\res\java\junit.jar ..\common\source\java\lib\junit.jar
if not exist ..\common\source\java\lib\mysql-connector-java-3.1.11a-bin.jar copy ..\common\res\java\mysql-connector-java-3.1.11a-bin.jar ..\common\source\java\lib\mysql-connector-java-3.1.11a-bin.jar
if not exist ..\common\source\java\lib\sapdbc-7_6_00_12_4339.jar copy ..\common\res\java\sapdbc-7_6_00_12_4339.jar ..\common\source\java\lib\sapdbc-7_6_00_12_4339.jar
if not exist ..\common\source\java\lib\ojdbc14.jar copy ..\win-external-libs\lib\java\ojdbc14.jar ..\common\source\java\lib\ojdbc14.jar
echo .

rem ------------------------------
rem copy images

echo Copying images and textures...
copy ..\common\images\grt\*.png bin\windows\images\
copy ..\common\images\grt\structs\*.png bin\windows\images\structs\
copy ..\common\images\textures\*.png bin\windows\images\textures\
copy ..\common\images\grt\icons\db\*.png bin\windows\images\grt\db\


rem ------------------------------
rem lua source files

echo Copying lua files...
copy ..\common\source\lua\*.lua bin\windows\lua\
copy source\lua\*.lua bin\windows\lua\

echo .

if not [%1] == [] popd

